/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = function (move) {
  return function (path, id) {
    path.splice(0, move.from.length);
    path.unshift.apply(path, move.to);
    for (var i = 0; i < move.to.length; i++) {
      if (path[i] === '$id') {
        path[i] = id;
      }
    }
  };
};

module.exports = exports['default'];