/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = iteratePathSet;
var marked0$0 = [iteratePathSet, iterateThing].map(_regeneratorRuntime.mark);

function iteratePathSet(pathSet) {
  var pointer = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];
  var path = arguments.length <= 2 || arguments[2] === undefined ? [] : arguments[2];

  var thing, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, x;

  return _regeneratorRuntime.wrap(function iteratePathSet$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        if (!(pointer >= pathSet.length)) {
          context$1$0.next = 5;
          break;
        }

        context$1$0.next = 3;
        return path.slice();

      case 3:
        context$1$0.next = 33;
        break;

      case 5:
        thing = pathSet[pointer];
        _iteratorNormalCompletion = true;
        _didIteratorError = false;
        _iteratorError = undefined;
        context$1$0.prev = 9;
        _iterator = _getIterator(iterateThing(thing));

      case 11:
        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
          context$1$0.next = 19;
          break;
        }

        x = _step.value;

        path.push(x);
        return context$1$0.delegateYield(iteratePathSet(pathSet, pointer + 1, path), 't0', 15);

      case 15:
        path.pop();

      case 16:
        _iteratorNormalCompletion = true;
        context$1$0.next = 11;
        break;

      case 19:
        context$1$0.next = 25;
        break;

      case 21:
        context$1$0.prev = 21;
        context$1$0.t1 = context$1$0['catch'](9);
        _didIteratorError = true;
        _iteratorError = context$1$0.t1;

      case 25:
        context$1$0.prev = 25;
        context$1$0.prev = 26;

        if (!_iteratorNormalCompletion && _iterator['return']) {
          _iterator['return']();
        }

      case 28:
        context$1$0.prev = 28;

        if (!_didIteratorError) {
          context$1$0.next = 31;
          break;
        }

        throw _iteratorError;

      case 31:
        return context$1$0.finish(28);

      case 32:
        return context$1$0.finish(25);

      case 33:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this, [[9, 21, 25, 33], [26,, 28, 32]]);
}

function iterateThing(thing) {
  var isArray, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _step2$value, from, to, i, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, item;

  return _regeneratorRuntime.wrap(function iterateThing$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        isArray = Array.isArray(thing);

        if (!(isArray && thing.length > 0 && typeof thing[0].from === 'number')) {
          context$1$0.next = 37;
          break;
        }

        _iteratorNormalCompletion2 = true;
        _didIteratorError2 = false;
        _iteratorError2 = undefined;
        context$1$0.prev = 5;
        _iterator2 = _getIterator(thing);

      case 7:
        if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
          context$1$0.next = 21;
          break;
        }

        _step2$value = _step2.value;
        from = _step2$value.from;
        to = _step2$value.to;
        i = from;

      case 12:
        if (!(i <= to)) {
          context$1$0.next = 18;
          break;
        }

        context$1$0.next = 15;
        return i;

      case 15:
        i++;
        context$1$0.next = 12;
        break;

      case 18:
        _iteratorNormalCompletion2 = true;
        context$1$0.next = 7;
        break;

      case 21:
        context$1$0.next = 27;
        break;

      case 23:
        context$1$0.prev = 23;
        context$1$0.t0 = context$1$0['catch'](5);
        _didIteratorError2 = true;
        _iteratorError2 = context$1$0.t0;

      case 27:
        context$1$0.prev = 27;
        context$1$0.prev = 28;

        if (!_iteratorNormalCompletion2 && _iterator2['return']) {
          _iterator2['return']();
        }

      case 30:
        context$1$0.prev = 30;

        if (!_didIteratorError2) {
          context$1$0.next = 33;
          break;
        }

        throw _iteratorError2;

      case 33:
        return context$1$0.finish(30);

      case 34:
        return context$1$0.finish(27);

      case 35:
        context$1$0.next = 80;
        break;

      case 37:
        if (!(typeof thing.from === 'number')) {
          context$1$0.next = 49;
          break;
        }

        from = thing.from;
        to = thing.to;
        i = from;

      case 41:
        if (!(i <= to)) {
          context$1$0.next = 47;
          break;
        }

        context$1$0.next = 44;
        return i;

      case 44:
        i++;
        context$1$0.next = 41;
        break;

      case 47:
        context$1$0.next = 80;
        break;

      case 49:
        if (!isArray) {
          context$1$0.next = 78;
          break;
        }

        _iteratorNormalCompletion3 = true;
        _didIteratorError3 = false;
        _iteratorError3 = undefined;
        context$1$0.prev = 53;
        _iterator3 = _getIterator(thing);

      case 55:
        if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
          context$1$0.next = 62;
          break;
        }

        item = _step3.value;
        context$1$0.next = 59;
        return item;

      case 59:
        _iteratorNormalCompletion3 = true;
        context$1$0.next = 55;
        break;

      case 62:
        context$1$0.next = 68;
        break;

      case 64:
        context$1$0.prev = 64;
        context$1$0.t1 = context$1$0['catch'](53);
        _didIteratorError3 = true;
        _iteratorError3 = context$1$0.t1;

      case 68:
        context$1$0.prev = 68;
        context$1$0.prev = 69;

        if (!_iteratorNormalCompletion3 && _iterator3['return']) {
          _iterator3['return']();
        }

      case 71:
        context$1$0.prev = 71;

        if (!_didIteratorError3) {
          context$1$0.next = 74;
          break;
        }

        throw _iteratorError3;

      case 74:
        return context$1$0.finish(71);

      case 75:
        return context$1$0.finish(68);

      case 76:
        context$1$0.next = 80;
        break;

      case 78:
        context$1$0.next = 80;
        return thing;

      case 80:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[1], this, [[5, 23, 27, 35], [28,, 30, 34], [53, 64, 68, 76], [69,, 71, 75]]);
}
module.exports = exports['default'];