/*
 * Copyright (c) 2015 by Greg Reimer <gregreimer@gmail.com>
 * MIT License. See mit-license.txt for more info.
 */

'use strict';

var _bind = require('babel-runtime/helpers/bind')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = graphify;
exports.extractor = extractor;

var _converter = require('./converter');

var _converter2 = _interopRequireDefault(_converter);

var _extractor = require('./extractor');

var _extractor2 = _interopRequireDefault(_extractor);

function graphify(opts) {
  return new _converter2['default'](opts);
}

function extractor() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new (_bind.apply(_extractor2['default'], [null].concat(args)))();
}