'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _WeakMap = require('babel-runtime/core-js/weak-map')['default'];

var _Object$create = require('babel-runtime/core-js/object/create')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Map = require('babel-runtime/core-js/map')['default'];

var _Number$isInteger = require('babel-runtime/core-js/number/is-integer')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var privates = new _WeakMap();

var PatternMap = (function () {
  function PatternMap() {
    _classCallCheck(this, PatternMap);

    var _ = _Object$create(null);
    privates.set(this, _);
  }

  _createClass(PatternMap, [{
    key: 'set',
    value: function set(path, value) {
      var _ = privates.get(this);
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _getIterator(path), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var step = _step.value;

          if (!_.children) {
            _.children = new _Map();
          }
          var child = _.children.get(step);
          if (!child) {
            child = new PatternMap();
            _.children.set(step, child);
          }
          _ = privates.get(child);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      _.value = value;
      _.hasValue = true;
    }
  }, {
    key: 'get',
    value: function get(path) {
      var _ = privates.get(this);
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = _getIterator(path), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var step = _step2.value;

          if (!_.children) {
            return undefined;
          }
          var child = _.children.get(step);
          if (!child && _Number$isInteger(step) && step >= 0) {
            child = _.children.get('$index');
          }
          if (!child) {
            child = _.children.get('$key');
          }
          if (!child) {
            return undefined;
          }
          _ = privates.get(child);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2['return']) {
            _iterator2['return']();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return _.value;
    }
  }]);

  return PatternMap;
})();

exports['default'] = PatternMap;
module.exports = exports['default'];